"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _postcss = _interopRequireDefault(require("postcss"));

var _postcssValueParser = _interopRequireWildcard(require("postcss-value-parser"));

var _colormin = _interopRequireDefault(require("colormin"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function reduceWhitespaces(decl) {
  decl.value = (0, _postcssValueParser["default"])(decl.value).walk(function (node) {
    if (node.type === 'function' || node.type === 'div') {
      node.before = node.after = '';
    }
  }).toString();
}

function walk(parent, callback) {
  parent.nodes.forEach(function (node, index) {
    var bubble = callback(node, index, parent);

    if (node.nodes && bubble !== false) {
      walk(node, callback);
    }
  });
}

function transform(decl, opts) {
  if (decl.prop === '-webkit-tap-highlight-color') {
    if (decl.value === 'inherit' || decl.value === 'transparent') {
      return;
    }

    reduceWhitespaces(decl);
    return;
  }

  if (/^(composes|font|filter)/i.test(decl.prop)) {
    return;
  }

  var ast = (0, _postcssValueParser["default"])(decl.value);
  walk(ast, function (node, index, parent) {
    if (node.type === 'function') {
      if (/^(rgb|hsl)a?$/.test(node.value)) {
        var value = node.value;
        node.value = (0, _colormin["default"])((0, _postcssValueParser.stringify)(node), opts);
        node.type = 'word';
        var next = parent.nodes[index + 1];

        if (node.value !== value && next && next.type === 'word') {
          parent.nodes.splice(index + 1, 0, {
            type: 'space',
            value: ' '
          });
        }
      } else if (node.value === 'calc') {
        return false;
      }
    } else {
      node.value = (0, _colormin["default"])(node.value, opts);
    }
  });
  decl.value = ast.toString();
}

var _default = _postcss["default"].plugin('postcss-colormin', function () {
  var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return function (css) {
    return css.walkDecls(function (node) {
      return transform(node, opts);
    });
  };
});

exports["default"] = _default;